\begin{exercise}{4.4}
  \begin{figure}[h!]
    \centering
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetFour/ex4/accuracies-train.pdf}
      \caption{train}
    \end{subfigure}\hfil
    \begin{subfigure}{0.5\linewidth}
      \includegraphics[width=\linewidth]{\RootPathSheetFour/ex4/accuracies.pdf}
      \caption{test}
    \end{subfigure}
    \caption{
      accuracies for different algorithms used for training.
    }
    \label{fig:4.4}
  \end{figure}
  The whole \texttt{MNIST} dataset has been used.


   The value \(k=1\) in KNN has been choose as the best among range \([1,15]\), using a CV.
   
   Figure~\ref{fig:4.4} shows the results of the training. KNN and linear regression perform good, while Naive Bayes and Quadratic Discriminant Analysis are really bad in classifying correct digits. NB bad performance can be explained with the fact that the independence of features does not hold\footnote{Applying a PCA can be really useful, but I didn't tried.}, while I can't really explain why QDA gets worse result than LDA.

  \pythoncode{\RootPathSheetFour/ex4/code.py}
\end{exercise}